leetcode 贪心算法

来源:互联网 发布:java json替换value值 编辑:程序博客网 时间:2024/06/14 21:54

455. Assign Cookies

Assume you are an awesome parent and want to give your children some cookies. But, you should give each child at most one cookie. Each child i has a greed factor gi, which is the minimum size of a cookie that the child will be content with; and each cookie j has a size sj. If sj >= gi, we can assign the cookie j to the child i, and the child i will be content. Your goal is to maximize the number of your content children and output the maximum number.

Note:
You may assume the greed factor is always positive. 
You cannot assign more than one cookie to one child.

Example 1:

Input: [1,2,3], [1,1]Output: 1Explanation: You have 3 children and 2 cookies. The greed factors of 3 children are 1, 2, 3. And even though you have 2 cookies, since their size is both 1, you could only make the child whose greed factor is 1 content.You need to output 1.
class Solution {public:    int findContentChildren(vector<int>& g, vector<int>& s) {        int res=0;        int childn=g.size();        int cookn=s.size();        if(!childn||!cookn) return res;        sort(g.begin(),g.end());        sort(s.begin(),s.end());        int i=0,j=0;        while(i<childn&&j<cookn)        {            if(s[j]>=g[i])            {                res++;                ++j;                ++i;            }            else                j++;        }        return res;    }};

55. Jump Game

我的方法:

class Solution {public:    bool canJump(vector<int>& nums) {        int last=nums.size()-1;        if(last==0) return true;        int first=last-1;        while(first>0)        {            while(last-first>nums[first]) first--;            if(first==0) return true;            if(first<0) return false;            last=first;            first=last-1;        }        if(last-first<=nums[first]) return true;        else return false;    }    };

其他思路:

这道题是动态规划的题目,所用到的方法跟是在Maximum Subarray中介绍的套路,用“局部最优和全局最优解法”。我们维护一个到目前为止能跳到的最远距离,以及从当前一步出发能跳到的最远距离。局部最优local=A[i]+i,而全局最优则是global=Math.max(global, local)。递推式出来了,代码就比较容易实现了。因为只需要一次遍历时间复杂度是O(n),而空间上是O(1)。代码如下: 

class Solution {public:    bool canJump(vector<int>& nums) {        int n=nums.size();        int reach=0;        for(int i=0;i<=reach&&i<n;i++)        {            reach=max(reach,nums[i]+i);        }        if(reach<n-1)            return false;        else            return true;    }};

45. Jump Game II

Given an array of non-negative integers, you are initially positioned at the first index of the array.

Each element in the array represents your maximum jump length at that position.

Your goal is to reach the last index in the minimum number of jumps.

For example:
Given array A = [2,3,1,1,4]

The minimum number of jumps to reach the last index is 2. (Jump 1 step from index 0 to 1, then 3 steps to the last index.)

Note:
You can assume that you can always reach the last index.

http://blog.csdn.net/makuiyu/article/details/43698969

class Solution {public:    int jump(vector<int>& nums) {        int n=nums.size();        int reach=0,last=0,step=0;        for(int i=0;i<=reach&&i<n;i++)        {            if(i>last)            {                last=reach;                step++;            }            reach=max(reach,nums[i]+i);        }        return reach<n-1?0:step;    }};



原创粉丝点击